import { Vector3 } from 'three';
import { Brick } from '.';
import type Rapier from '@dimforge/rapier3d-compat';

export class MeshPart extends Brick {
  public objectType = 'MeshPart';

  protected override createCollider(
    factory: typeof Rapier,
    world: Rapier.World,
    body?: Rapier.RigidBody,
  ) {
    const scale = this.getWorldScale(new Vector3()).divideScalar(2);
    const collider = factory.ColliderDesc.cuboid(
      Math.abs(scale.x),
      Math.abs(scale.y),
      Math.abs(scale.z),
    );
    return world.createCollider(collider, body);
  }
}
