import { ObjectProperty } from 'src/types/property.decorator';
import { GameObject } from './game-object';

export class World extends GameObject {
  public objectType = 'World';
  public name = 'World';
  public virtual = true;

  @ObjectProperty()
  public gravity = -9.81;

  override get properties() {
    const properties = super.properties;
    return properties.filter((prop) => ['gravity'].includes(prop));
  }
}
