import type Rapier from '@dimforge/rapier3d-compat';
import { Quaternion, Vector3 } from 'three';

export interface PhysicsTicking {
  position: Vector3;
  quaternion: Quaternion;
  /**
   * @internal
   */
  isTickingObject: boolean;

  /**
   * @internal
   */
  uuid: string;

  /**
   * @internal
   */
  initialize(
    physicsEngine: typeof Rapier,
    physicsWorld: Rapier.World,
    controller?: Rapier.KinematicCharacterController,
  ): void;

  /**
   * @internal
   */
  tick(dt: number): void;
}
