export enum PacketType {
  /**
   * [][Player ID][Session Token][Client Version]
   */
  AUTH = 0,
  KEEPALIVE,
  /**
   * [][World name]
   */
  STREAM_START,
  /**
   * [][Asset Path][Asset Name][Asset Type][Buffer]
   */
  STREAM_ASSET,
  /**
   * [][Object UUID][Parent UUID][Object Type][Object data JSON]
   */
  STREAM_OBJECT,
  /**
   * [][Object UUID]
   */
  STREAM_DESTROY,
  /**
   * [][Object UUID][Event][JSON]
   */
  STREAM_EVENT,
  /**
   * [][World name]
   */
  STREAM_FINISH,
  /**
   * [][UUID][x y z Position][x y z w Rotation][x y z linvel][x y z angvel]
   */
  STREAM_TRANSFORM,
  /**
   * [][Player ID][Chat Type][Chat Message]
   */
  STREAM_CHAT,
  /**
   * [][Player count][Player ID:Player Name]
   */
  PLAYER_LIST,
  /**
   * [][Player ID][Player Name]
   */
  PLAYER_JOIN,
  /**
   * [][Player ID][Player Name][Reason]
   */
  PLAYER_QUIT,
  /**
   * [][Player ID][Player Name][x y z Position][x y z w quaternion][Object UUID][Data...]
   */
  PLAYER_CHARACTER,
  /**
   * [][Player ID][Velocity][LookAt][Jump][AnimState]
   */
  PLAYER_MOVEMENT,
  /**
   * [][Player ID][Chat Type][Chat Message]
   */
  PLAYER_CHAT,
  /**
   * [][Player ID][Object UUID][Event][JSON]
   */
  PLAYER_EVENT,
  /**
   * [][Error type]
   */
  ERROR,
}
